import { EventEmitter, OnInit, QueryList } from "@angular/core";
import { FormGroup } from "@angular/forms";
import { DynamicFormControlModel, DynamicFormArrayGroupModel, DynamicFormControlComponent, DynamicFormControlEvent, DynamicTemplateDirective } from "@ng2-dynamic-forms/core";
export declare const enum BootstrapFormControlType {
    Array = "ARRAY",
    Checkbox = "CHECKBOX",
    Group = "GROUP",
    Input = "INPUT",
    RadioGroup = "RADIO_GROUP",
    Select = "SELECT",
    TextArea = "TEXTAREA",
}
export declare class DynamicFormBootstrapComponent extends DynamicFormControlComponent implements OnInit {
    asBootstrapFormGroup: boolean;
    bindId: boolean;
    context: DynamicFormArrayGroupModel;
    group: FormGroup;
    hasErrorMessaging: boolean;
    model: DynamicFormControlModel;
    nestedTemplates: QueryList<DynamicTemplateDirective>;
    blur: EventEmitter<DynamicFormControlEvent>;
    change: EventEmitter<DynamicFormControlEvent>;
    focus: EventEmitter<DynamicFormControlEvent>;
    templates: QueryList<DynamicTemplateDirective>;
    type: BootstrapFormControlType | null;
    constructor();
    ngOnInit(): void;
    static getFormControlType(model: DynamicFormControlModel): BootstrapFormControlType | null;
}
