var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ContentChildren, Input, EventEmitter, Output, QueryList } from "@angular/core";
import { FormGroup } from "@angular/forms";
import { DynamicFormControlModel, DynamicFormArrayGroupModel, DynamicFormControlComponent, DynamicTemplateDirective, DYNAMIC_FORM_CONTROL_TYPE_ARRAY, DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX, DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX_GROUP, DYNAMIC_FORM_CONTROL_TYPE_GROUP, DYNAMIC_FORM_CONTROL_TYPE_INPUT, DYNAMIC_FORM_CONTROL_TYPE_RADIO_GROUP, DYNAMIC_FORM_CONTROL_TYPE_SELECT, DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA } from "@ng2-dynamic-forms/core";
var DynamicFormBootstrapComponent = (function (_super) {
    __extends(DynamicFormBootstrapComponent, _super);
    function DynamicFormBootstrapComponent() {
        var _this = _super.call(this) || this;
        _this.asBootstrapFormGroup = true;
        _this.bindId = true;
        _this.context = null;
        _this.hasErrorMessaging = false;
        _this.blur = new EventEmitter();
        _this.change = new EventEmitter();
        _this.focus = new EventEmitter();
        return _this;
    }
    DynamicFormBootstrapComponent_1 = DynamicFormBootstrapComponent;
    DynamicFormBootstrapComponent.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
        this.type = DynamicFormBootstrapComponent_1.getFormControlType(this.model);
    };
    DynamicFormBootstrapComponent.getFormControlType = function (model) {
        switch (model.type) {
            case DYNAMIC_FORM_CONTROL_TYPE_ARRAY:
                return "ARRAY" /* Array */;
            case DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX:
                return "CHECKBOX" /* Checkbox */;
            case DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX_GROUP:
            case DYNAMIC_FORM_CONTROL_TYPE_GROUP:
                return "GROUP" /* Group */;
            case DYNAMIC_FORM_CONTROL_TYPE_INPUT:
                return "INPUT" /* Input */;
            case DYNAMIC_FORM_CONTROL_TYPE_RADIO_GROUP:
                return "RADIO_GROUP" /* RadioGroup */;
            case DYNAMIC_FORM_CONTROL_TYPE_SELECT:
                return "SELECT" /* Select */;
            case DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA:
                return "TEXTAREA" /* TextArea */;
            default:
                return null;
        }
    };
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DynamicFormBootstrapComponent.prototype, "asBootstrapFormGroup", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DynamicFormBootstrapComponent.prototype, "bindId", void 0);
    __decorate([
        Input(),
        __metadata("design:type", DynamicFormArrayGroupModel)
    ], DynamicFormBootstrapComponent.prototype, "context", void 0);
    __decorate([
        Input(),
        __metadata("design:type", FormGroup)
    ], DynamicFormBootstrapComponent.prototype, "group", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DynamicFormBootstrapComponent.prototype, "hasErrorMessaging", void 0);
    __decorate([
        Input(),
        __metadata("design:type", DynamicFormControlModel)
    ], DynamicFormBootstrapComponent.prototype, "model", void 0);
    __decorate([
        Input(),
        __metadata("design:type", QueryList)
    ], DynamicFormBootstrapComponent.prototype, "nestedTemplates", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DynamicFormBootstrapComponent.prototype, "blur", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DynamicFormBootstrapComponent.prototype, "change", void 0);
    __decorate([
        Output(),
        __metadata("design:type", EventEmitter)
    ], DynamicFormBootstrapComponent.prototype, "focus", void 0);
    __decorate([
        ContentChildren(DynamicTemplateDirective),
        __metadata("design:type", QueryList)
    ], DynamicFormBootstrapComponent.prototype, "templates", void 0);
    DynamicFormBootstrapComponent = DynamicFormBootstrapComponent_1 = __decorate([
        Component({
            selector: "dynamic-form-bootstrap-control",
            template: "<div [class.form-group]=\"asBootstrapFormGroup || model.cls.element.container.includes('form-group')\" [class.has-error]=\"hasErrorMessaging && !hasFocus && isInvalid\" [formGroup]=\"group\" [ngClass]=\"[model.cls.element.container, model.cls.grid.container]\"><label *ngIf=\"type !== 'CHECKBOX' && model.label !== null\" [attr.for]=\"model.id\" [innerHTML]=\"model.label\" [ngClass]=\"[model.cls.element.label, model.cls.grid.label]\"></label><ng-template *ngIf=\"hasStartTemplate && type !== 'ARRAY'\" [ngTemplateOutlet]=\"template\" [ngTemplateOutletContext]=\"model\"></ng-template><div *ngIf=\"type === 'CHECKBOX'\" [ngClass]=\"model.cls.grid.control\"><div class=\"checkbox\" [class.disabled]=\"model.disabled\"><label><input type=\"checkbox\" [attr.tabindex]=\"model.tabIndex\" [checked]=\"model.checked\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [required]=\"model.required\" [value]=\"model.value\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"><span [innerHTML]=\"model.label\" [ngClass]=\"[model.cls.element.label, model.cls.grid.label]\"></span></label></div></div><div *ngIf=\"type !== 'CHECKBOX'\" [ngClass]=\"model.cls.grid.control\"><ng-container [ngSwitch]=\"type\"><div *ngSwitchCase=\"'ARRAY'\" [dynamicId]=\"bindId && model.id\" [formArrayName]=\"model.id\" [ngClass]=\"model.cls.element.control\"><fieldset *ngFor=\"let groupModel of model.groups; let idx = index\" [formGroupName]=\"idx\"><dynamic-form-bootstrap-control *ngFor=\"let controlModel of groupModel.group\" [bindId]=\"false\" [context]=\"groupModel\" [group]=\"control.at(idx)\" [hasErrorMessaging]=\"controlModel.hasErrorMessages\" [model]=\"controlModel\" [nestedTemplates]=\"templateDirectives\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"></dynamic-form-bootstrap-control><ng-template [ngTemplateOutlet]=\"template\" [ngTemplateOutletContext]=\"groupModel\"></ng-template></fieldset></div><fieldset *ngSwitchCase=\"'GROUP'\" [dynamicId]=\"bindId && model.id\" [formGroupName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\"><legend *ngIf=\"model.legend\" [innerHTML]=\"model.legend\"></legend><dynamic-form-bootstrap-control *ngFor=\"let controlModel of model.group\" [asBootstrapFormGroup]=\"false\" [group]=\"control\" [hasErrorMessaging]=\"controlModel.hasErrorMessages\" [model]=\"controlModel\" [nestedTemplates]=\"templateDirectives\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"></dynamic-form-bootstrap-control></fieldset><div *ngSwitchCase=\"'INPUT'\" [class.input-group]=\"model.prefix || model.suffix\"><div *ngIf=\"model.prefix\" class=\"input-group-addon\" [innerHTML]=\"model.prefix\"></div><input class=\"form-control\" [attr.accept]=\"model.accept\" [attr.autoComplete]=\"model.autoComplete\" [attr.list]=\"model.listId\" [attr.max]=\"model.max\" [attr.min]=\"model.min\" [attr.multiple]=\"model.multiple\" [attr.step]=\"model.step\" [attr.tabindex]=\"model.tabIndex\" [autofocus]=\"model.autoFocus\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [pattern]=\"model.pattern\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [spellcheck]=\"model.spellCheck\" [textMask]=\"{mask: (model.mask || false), showMask: model.mask && !(model.placeholder)}\" [type]=\"model.inputType\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"><div *ngIf=\"model.suffix\" class=\"input-group-addon\" [innerHTML]=\"model.suffix\"></div><datalist *ngIf=\"model.list\" [id]=\"model.listId\"><option *ngFor=\"let option of model.list\" [value]=\"option\"></option></datalist></div><fieldset *ngSwitchCase=\"'RADIO_GROUP'\" role=\"radiogroup\" [attr.tabindex]=\"model.tabIndex\" [dynamicId]=\"bindId && model.id\" [name]=\"model.name\" (change)=\"onValueChange($event)\"><legend *ngIf=\"model.legend\" [innerHTML]=\"model.legend\"></legend><div *ngFor=\"let option of model.options$ | async\" class=\"radio\"><label><input type=\"radio\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [value]=\"option.value\" (blur)=\"onFocusChange($event)\" (focus)=\"onFocusChange($event)\"><span [innerHTML]=\"option.label\"></span></label></div></fieldset><select *ngSwitchCase=\"'SELECT'\" class=\"form-control\" [attr.tabindex]=\"model.tabIndex\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [required]=\"model.required\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"><option *ngFor=\"let option of model.options$ | async\" [attr.name]=\"model.name\" [ngValue]=\"option.value\">{{option.label}}</option></select><textarea *ngSwitchCase=\"'TEXTAREA'\" class=\"form-control\" [attr.tabindex]=\"model.tabIndex\" [dynamicId]=\"bindId && model.id\" [cols]=\"model.cols\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [rows]=\"model.rows\" [spellcheck]=\"model.spellCheck\" [wrap]=\"model.wrap\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"></textarea><span *ngIf=\"model.hint\" class=\"help-block\" [innerHTML]=\"model.hint\" [ngClass]=\"model.cls.element.hint\"></span></ng-container></div><ul *ngIf=\"hasErrorMessaging\" class=\"has-error\" [class.hidden]=\"!showErrorMessages\" [ngClass]=\"[model.cls.grid.errors]\"><li *ngFor=\"let message of errorMessages\" class=\"help-block\" [ngClass]=\"[model.cls.element.errors]\">{{message}}</li></ul><ng-template *ngIf=\"hasEndTemplate && type !== 'ARRAY'\" [ngTemplateOutlet]=\"template\" [ngTemplateOutletContext]=\"model\"></ng-template><ng-content></ng-content></div>"
        }),
        __metadata("design:paramtypes", [])
    ], DynamicFormBootstrapComponent);
    return DynamicFormBootstrapComponent;
    var DynamicFormBootstrapComponent_1;
}(DynamicFormControlComponent));
export { DynamicFormBootstrapComponent };

//# sourceMappingURL=dynamic-form-bootstrap.component.js.map
